# TP 20 : Parcours de graphes
# BCPST1B 2023-2024
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

#%% graphe d'exemple

G_exemple = {'A': ['B', 'D'], 'B': ['C'], 'C': ['E', 'F'], 'D': ['E'], 'E': ['B'], 'F': [], 'G': ['C']}

#%% tracer un graphe

import networkx as nx
import matplotlib.pyplot as plt

G = nx.DiGraph(G_exemple)
nx.draw_networkx(G, arrowsize=25, node_size=800, font_size=8, node_color="white", edgecolors="black")
plt.show()

#%% section I

def parcours_profondeur(G, x):
    ...

vus = []
parcours_profondeur(G_exemple, "A")
print(vus)

#%% section II

def parcours_largeur(G, x):
    ...

vus = []
avoir = []
parcours_largeur(G_exemple, "A")
print(vus)

#%% labyrinthes

import numpy as np
import matplotlib.pyplot as plt

lab1 = [[1,1,1,1,1,0,0,0,0,0,1],
        [1,0,0,0,1,0,1,0,1,0,1],
        [1,0,1,0,1,0,1,0,1,0,1],
        [1,0,1,0,1,0,1,0,1,0,1],
        [1,0,1,0,1,0,1,0,1,0,1],
        [0,0,1,0,0,0,1,0,1,0,0],
        [1,1,1,1,1,1,1,0,1,0,1],
        [1,0,0,0,1,0,0,0,1,0,1],
        [1,0,1,0,1,0,1,1,1,0,1],
        [1,0,1,1,1,0,1,0,0,0,1],
        [1,0,0,0,0,0,1,1,0,1,1]]

# dessine avec matplotlib
X1 = np.array(lab1)
plt.tick_params(left=False, labelleft=False, bottom=False, labelbottom=False) 
plt.imshow(1-X1, cmap="gray", vmin=0, vmax=1)
plt.show()

# transforme en dictionnaire d'adjacence
def convertit(L):
    n = len(L)
    p = len(L[0])
    G = {}
    for i in range(n):
        for j in range(p):
            if L[i][j] == 0:
                G[(i, j)] = []
                if i >= 1 and L[i-1][j] == 0:
                    G[(i, j)].append((i-1, j))
                if j >= 1 and L[i][j-1] == 0:
                    G[(i, j)].append((i, j-1))
                if i <= n-2 and L[i+1][j] == 0:
                    G[(i, j)].append((i+1, j))
                if j <= p-2 and L[i][j+1] == 0:
                    G[(i, j)].append((i, j+1))
    return G

G1 = convertit(lab1)
print(G1)

#%%
# G1 est un dictionnaire d'adjacence, tester les parcours avec

#%% le générateur de labyrinthes
# merci à Quentin FORTIER pour ce code

import numpy as np
import matplotlib.pyplot as plt
import networkx as nx
import random

n = 10
p = 10

def generate_labyrinth(n, p):
    G = nx.Graph()
    G.add_nodes_from((i, j) for i in range(n) for j in range(p))
    visited = [[False]*p for _ in range(n)]
    def dfs(i, j):
        visited[i][j] = True
        neighbors = [(i+1, j), (i-1, j), (i, j+1), (i, j-1)]
        random.shuffle(neighbors)
        for x, y in neighbors:
            if 0 <= x < n and 0 <= y < p and not visited[x][y]:
                G.add_edge((i, j), (x, y))
                dfs(x, y)
    dfs(n - 1, 0)
    return G

G = generate_labyrinth(n, p)
L = [[1 for j in range (2*p-1)] for i in range(2*n-1)]
for i in range(n):
    for j in range(p):
        if (i, j) in nx.nodes(G):
            L[2*i][2*j] = 0
for i in range(n-1):
    for j in range(p):
        if G.has_edge((i+1,j),(i,j)):
            L[2*i+1][2*j] = 0
for i in range(n):
    for j in range(p-1):
        if G.has_edge((i,j),(i,j+1)):
            L[2*i][2*j+1] = 0
        
X = np.array(L)
plt.tick_params(left=False, labelleft=False, bottom=False, labelbottom=False)
plt.imshow(1-X, cmap="gray", vmin=0, vmax=1)
plt.show()

# L peut être converti (avec la fonction précédente) en dictionnaire d'adjacence
